/************************************************************************/
/*									*/
/* ĴѴؿ (OS¸)						*/
/*									*/
/* ڴؿ								*/
/*									*/
/* int  wait_vsync_init( void )		 (ư˸ƤӽФ)	*/
/* void wait_vsync_term( void )		λ   (λ˸ƤӽФ)	*/
/*									*/
/* void	wait_vsync_reset( void )	¬ꥻå (ѹ)	*/
/* void wait_vsync( void )		Ȥ (ֳַвԤ)	*/
/*									*/
/* void wait_menu( void )		˥塼ѥ(1/60secԤ)	*/
/*									*/
/************************************************************************/
#include <stdio.h>

#include <SDL.h>

#include "quasi88.h"
#include "initval.h"
#include "wait.h"
#include "suspend.h"

#include "screen.h"	/* auto_skip... */



/*
 * ưե졼ॹå		( by floi, thanks ! )
 */

static	int	skip_counter = 0;		/* Ϣ³󥹥åפ */
static	int	skip_count_max = 15;		/* ʾϢ³åפ
						   öŪ褹 */


/*
 * Ƚؿ
 */

static	int	wait_counter = 0;		/* Ϣ³֥С*/
static	int	wait_count_max = 10;		/* ʾϢ³С
						   ö,Ĵ */

/* Ĵϡusñ̤ǹԤʤǤѿη long ʤΤ 4295 äͤ
   ä(wrap)ޤλ 1ե졼ϥߥ󥰤
   ʤΤǡǽʤ 64bit(long long)ˤƤߤ褦 */

#ifdef SDL_HAS_64BIT_TYPE
typedef	Sint64		T_WAIT_TICK;
#else
typedef	long		T_WAIT_TICK;
#endif

static	T_WAIT_TICK	next_time;		/* ե졼λ */
static	T_WAIT_TICK	delta_time;		/* 1 ե졼λ */



/* ---- ߻ (usecñ) ---- */

#define	GET_TICK()	( (T_WAIT_TICK)SDL_GetTicks() * 1000 )





/****************************************************************************
 * Ƚ
 *****************************************************************************/
int	wait_vsync_init( void )
{
  if( ! SDL_WasInit( SDL_INIT_TIMER ) ){
    if( SDL_InitSubSystem( SDL_INIT_TIMER ) != 0 ){
      if( verbose_wait ) printf( "Error Wait (SDL)\n" );
      return FALSE;
    }
  }

  wait_vsync_reset();
  return TRUE;
}



/****************************************************************************
 * Ƚλ
 *****************************************************************************/
void	wait_vsync_term( void )
{
}



/****************************************************************************
 * Ƚƽ
 *****************************************************************************/
void	wait_vsync_reset( void )
{
  wait_counter = 0;

  delta_time = (T_WAIT_TICK)(1000000.0/( CONST_VSYNC_FREQ * wait_rate / 100 ));
  next_time  = GET_TICK() + delta_time;

  /* delta_time >= 1000000us (1sec) ˤʤȡäȤޤ */
}



/****************************************************************************
 * Ƚ
 *****************************************************************************/
void	wait_vsync( void )
{
  int	on_time = FALSE;
  int	slept   = FALSE;
  T_WAIT_TICK	diff_ms;


  diff_ms = ( next_time - GET_TICK() ) / 1000;

  if( diff_ms > 0 ){	    /* ޤ֤;äƤʤ */
			    /* diff_ms ߥá */

    if( wait_by_sleep ){	/* ֤ޤ sleep  */

#if 1	/* ˡ 1) */
      SDL_Delay( diff_ms );		/* diff_ms ߥáǥ쥤   */
      slept = TRUE;

#else	/* ˡ 2) */
      if( diff_ms < 10 ){		/* 10ms̤ʤӥ */
	while( GET_TICK() <= next_time )
	  ;
      }else{				/* 10msʾʤǥ쥤       */
	SDL_Delay( diff_ms );
	slept = TRUE;
      }
#endif

    }else{			/* ֤ޤ Tick ƻ뤹 */

      while( GET_TICK() <= next_time )
	;
    }

    on_time = TRUE;
  }


  if( slept == FALSE ){		/* ٤ SDL_Delay ʤä */
    SDL_Delay( 1 );				/* for AUDIO thread ?? */
  }


  next_time += delta_time;


  if( on_time ){			/* ˽Ǥ */
    wait_counter = 0;
  }else{				/* ˽ǤƤʤ */
    wait_counter ++;
    if( wait_counter >= wait_count_max ){	/* ٤줬Ҥɤ */
      wait_vsync_reset();			/* Ȥ   */
    }
  }



  /*
   * ưե졼ॹå׽		( by floi, thanks ! )
   */
  if( use_auto_skip ){
    if( on_time ){			/* ˽Ǥ */
      skip_counter = 0;
      do_skip_draw = FALSE;
      if( already_skip_draw ){		/* 򥹥åפƤ */
	already_skip_draw = FALSE;
	reset_frame_counter();		/* ɬ褹 */
      }
    }else{				/* ˽ǤƤʤ */
      skip_counter++;
      if( skip_counter >= skip_count_max ){	/* åפ */
	skip_counter = 0;
	do_skip_draw = FALSE;
	already_skip_draw = FALSE;
	reset_frame_counter();			/* ɬ褹 */
      }else{
	do_skip_draw = TRUE;			/* 򥹥åפɬͭ*/
      }
    }
  }

  return;
}



/****************************************************************************
 * ˥塼ѤΥ
 *	 1/60 äۤԤġ٤פǽʤɬ sleep ٤
 *****************************************************************************/
void	wait_menu( void )
{
  SDL_Delay( 20 );
}
